package xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.serializer;

import java.util.Set;
import java.util.function.BiFunction;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.Context;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.ParsingException;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.tag.Tag;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.tag.resolver.ArgumentQueue;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.tag.resolver.TagResolver;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

final class StyleClaimingResolverImpl implements TagResolver, SerializableResolver.Single {
   private final @NotNull Set<String> names;
   private final @NotNull BiFunction<ArgumentQueue, Context, Tag> handler;
   private final @NotNull StyleClaim<?> styleClaim;

   StyleClaimingResolverImpl(final @NotNull Set<String> names, final @NotNull BiFunction<ArgumentQueue, Context, Tag> handler, final @NotNull StyleClaim<?> styleClaim) {
      this.names = names;
      this.handler = handler;
      this.styleClaim = styleClaim;
   }

   public @Nullable Tag resolve(final @NotNull String name, final @NotNull ArgumentQueue arguments, final @NotNull Context ctx) throws ParsingException {
      return !this.names.contains(name) ? null : (Tag)this.handler.apply(arguments, ctx);
   }

   public boolean has(final @NotNull String name) {
      return this.names.contains(name);
   }

   public @Nullable StyleClaim<?> claimStyle() {
      return this.styleClaim;
   }
}
